﻿using Infragistics.Win;
using Infragistics.Win.UltraWinMaskedEdit;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ToolbarsManagerPopupDrawFilterTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();            
            ultraToolbarsManager1.CreationFilter = new ToolbarsManagerCreationFilter();

            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraToolbar toolbar = ultraToolbarsManager1.Toolbars[0];
            PopupMenuTool menu = toolbar.Tools[0] as PopupMenuTool;

            foreach (var tool in menu.Tools)
            {
                tool.SharedProps.DescriptionOnMenu = "Description on Menu!";
                tool.SharedProps.AppearancesLarge.AppearanceOnMenu.BackColor = Color.LightBlue;
                tool.SharedProps.AppearancesLarge.AppearanceOnMenu.BackColor2 = Color.LightBlue;
                tool.SharedProps.AppearancesSmall.AppearanceOnMenu.BackColor = Color.LightBlue;
                tool.SharedProps.AppearancesSmall.AppearanceOnMenu.BackColor2 = Color.LightBlue;
            }
        }
    }

    public class ToolbarsManagerCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is PopupMenuItemDescriptionUIElement)
            {
                var parentElement = parent.Parent;
                IEnumerable<ImageAndTextButtonUIElement> buttonChildElements = parentElement.ChildElements.OfType<ImageAndTextButtonUIElement>().ToList();
                if (!buttonChildElements.Any())
                {
                    ImageAndTextButtonUIElement imageElement = new ImageAndTextButtonUIElement(parentElement)
                    {
                        Rect = new Rectangle(parentElement.RectInsideBorders.Width - 30, parentElement.RectInsideBorders.Top, 16, 16),
                        Style = UIElementButtonStyle.Borderless
                    };

                    imageElement.Appearance = new Infragistics.Win.Appearance()
                    {
                        ThemedElementAlpha = Alpha.Transparent,
                        BackColor = Color.Transparent
                    };

                    imageElement.Image = Bitmap.FromFile("../../Images/16x16-icon-45590.png");
                    imageElement.ElementClick += ImageElement_ElementClick;
                    parentElement.ChildElements.Add(imageElement);
                }
                else if (buttonChildElements.Count() == 1)
                {
                    ImageAndTextButtonUIElement imageAndTextButtonUIElement = buttonChildElements.First();                    
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        private void ImageElement_ElementClick(object sender, UIElementEventArgs e)
        {
            
        }
    }
}
